; -------------------------------------------------------------------
    .model small,c
    .386
    .stack

    include support.asm

.data
.code
; -------------------------------------------------------------------
; This proc returns a 32-bit bitmask representing the currently
; available logical drives, with bit 0 representing drive A, bit 1
; drive B, bit 3 drive C, etc. The bitmask is constructed by calling
; the IOCTL - Is Drive Remote function (DOS 3.1+) for all possible
; drives. Note that the function expects the drive parameter in BX
; and interprets the value as 0 = default drive, 1 = A, 2 = B, etc,
; and that the local/remote status of the drive is ignored.
; -------------------------------------------------------------------
GetLogicalDrives proc c uses ebx

    LOCAL bm:DWORD

    mov bm, 0
    mov bx, 1
    .WHILE bx < 27
      mov ax, 4409h
      int 21h
      jc  @F
      mov eax, 1
      mov cl, bl
      dec cl
      shl eax, cl
      or bm, eax
    @@:
      inc bx
    .ENDW
    mov eax, bm
    ret

GetLogicalDrives endp
; -------------------------------------------------------------------
.startup
; -------------------------------------------------------------------
    call GetLogicalDrives
    xor cl, cl
    .WHILE cl < 26
      mov edx, 1
      shl edx, cl
      and edx, eax
      jz  @F
      mov dl, cl
      add dl, 'A'
      putch dl
    @@:
      inc cl
    .ENDW

    print NL,"Press any normal key to exit...",NL
    call waitkey
; -------------------------------------------------------------------
.exit
end
